#include "lmbf.h"
// #include <TApplication>
// cumbia
#include <cumbiapool.h>
#include <cuthreadfactoryimpl.h>
#include <qthreadseventbridgefactory.h>
// cumbia

#include <quapplication.h>//	TApplication is mapped into QuApplication. DBus connection is provided by the cumbia dbus plugin	//	 ## added by qumbiaprojectwizard
// #include <tutil.h>
// no cumbia include replacement found for tutil.h
#include <X11/Xlib.h>
#include <QX11Info>
// #include <elettracolors.h>
// no cumbia include replacement found for elettracolors.h

#define CVSVERSION "$Name:  $"


int main(int argc, char *argv[])
{
    char *argvdevices[4];
    argc=4;
    argvdevices[0]=strdup(argv[0]);
    QString wtitle;
    
    argvdevices[1]=strdup("lmbf/delay/l");
    argvdevices[2]=strdup("lmbf/rfampl/l");
    argvdevices[3]=strdup("lmbf/processor/l");
    wtitle = "LMBF (Z)";
    
    QuApplication qu_app( argc, argvdevices );//	TApplication is mapped into QuApplication. DBus connection is provided by cumbia dbus plugin	//	 ## added by qumbiaprojectwizard
    qu_app.setOrganizationName("Elettra");
    qu_app.setApplicationName("lmbf-gui");
    QString version(CVSVERSION);
    qu_app.setApplicationVersion(version);
    qu_app.setProperty("author", "Claudio Scafuri");
    qu_app.setProperty("mail", "claudio.scafuri@elettra.eu");
    qu_app.setProperty("phone", "8009");
    qu_app.setProperty("office", "T2 P1 28");
    qu_app.setProperty("hwReferent", "-"); /* name of the referent that provides the device server */


    CumbiaPool *cu_p = new CumbiaPool();
    LmbfGui *w = new LmbfGui(cu_p, 0);
    w->setWindowTitle(wtitle);
    w->show();

    Display *disp = QX11Info::display();
    Window root_win = (Window) w->winId();
    XSetCommand(disp, root_win, argv, argc);

// exec application loop
    int ret = qu_app.exec();
    // delete resources and return
    delete w;

    for(std::string n : cu_p->names())
        if(cu_p->get(n))
            delete cu_p->get(n);

    return ret;


}

